/*!
  iPages - jQuery Flipbook PDF Viewer Plugin
  @name jquery.ipages.js
  @description jQuery plugin for creating a responsive flipbook viewer, support HTML, images and PDF content
  @version 1.4.3
  @author Max Lavrentiev
  @site http://www.avirtum.com
  @copyright (c) Max Lavrentiev
*/
!function(f,m,b,r){"use strict";function g(){this.reset()}g.prototype={reset:function(){return this.m=[1,0,0,1,0,0],this},multiply:function(t){var e=this.m[0]*t.m[0]+this.m[2]*t.m[1],o=this.m[1]*t.m[0]+this.m[3]*t.m[1],s=this.m[0]*t.m[2]+this.m[2]*t.m[3],i=this.m[1]*t.m[2]+this.m[3]*t.m[3],a=this.m[0]*t.m[4]+this.m[2]*t.m[5]+this.m[4],t=this.m[1]*t.m[4]+this.m[3]*t.m[5]+this.m[5];return this.m[0]=e,this.m[1]=o,this.m[2]=s,this.m[3]=i,this.m[4]=a,this.m[5]=t,this},inverse:function(){var t=new g,e=(t.m=this.m.slice(0),1/(t.m[0]*t.m[3]-t.m[1]*t.m[2])),o=t.m[3]*e,s=-t.m[1]*e,i=-t.m[2]*e,a=t.m[0]*e,n=e*(t.m[2]*t.m[5]-t.m[3]*t.m[4]),e=e*(t.m[1]*t.m[4]-t.m[0]*t.m[5]);return t.m[0]=o,t.m[1]=s,t.m[2]=i,t.m[3]=a,t.m[4]=n,t.m[5]=e,t},rotate:function(t){var e=Math.cos(t),t=Math.sin(t),o=this.m[0]*e+this.m[2]*t,s=this.m[1]*e+this.m[3]*t,i=this.m[0]*-t+this.m[2]*e,t=this.m[1]*-t+this.m[3]*e;return this.m[0]=o,this.m[1]=s,this.m[2]=i,this.m[3]=t,this},translate:function(t,e){return this.m[4]+=this.m[0]*t+this.m[2]*e,this.m[5]+=this.m[1]*t+this.m[3]*e,this},scale:function(t,e){return this.m[0]*=t,this.m[1]*=t,this.m[2]*=e,this.m[3]*=e,this},transformPoint:function(t,e){var o=t,s=e;return[t=o*this.m[0]+s*this.m[2]+this.m[4],e=o*this.m[1]+s*this.m[3]+this.m[5]]},transformVector:function(t,e){var o=t,s=e;return[t=o*this.m[0]+s*this.m[2],e=o*this.m[1]+s*this.m[3]]},copy:function(){(new g).m=this.m.slice(0)}},t="undefined"!=typeof self&&self||void 0!==m&&m||this.content||this,l=t.Uint8Array,t=t.HTMLCanvasElement,e=t&&t.prototype,d=/\s*;\s*base64\s*(?:;|$)/i,u="toDataURL",l&&(c=new l([62,-1,-1,-1,63,52,53,54,55,56,57,58,59,60,61,-1,-1,-1,0,-1,-1,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,-1,-1,-1,-1,-1,-1,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51])),!t||e.toBlob&&e.toBlobHD||(e.toBlob||(e.toBlob=function(t,e){var o,s,i,a;e=e||"image/png",this.mozGetAsFile?t(this.mozGetAsFile("canvas",e)):this.msToBlob&&/^\s*image\/png\s*(?:$|;)/i.test(e)?t(this.msToBlob()):(i=Array.prototype.slice.call(arguments,1),o=(i=this[u].apply(this,i)).indexOf(","),s=i.substring(o+1),i=d.test(i.substring(0,o)),Blob.fake?((a=new Blob).encoding=i?"base64":"URI",a.data=s,a.size=s.length):l&&(a=i?new Blob([function(t){for(var e,o,s=t.length,i=new l(s/4*3|0),a=0,n=0,h=[0,0],r=0,g=0;s--;)o=t.charCodeAt(a++),255!==(e=c[o-43])&&void 0!==e&&(h[1]=h[0],h[0]=o,g=g<<6|e,4===++r&&(i[n++]=g>>>16,61!==h[1]&&(i[n++]=g>>>8),61!==h[0]&&(i[n++]=g),r=0));return i}(s)],{type:e}):new Blob([decodeURIComponent(s)],{type:e})),t(a))}),!e.toBlobHD&&e.toDataURLHD?e.toBlobHD=function(){u="toDataURLHD";var t=this.toBlob();return u="toDataURL",t}:e.toBlobHD=e.toBlob);var t,c,l,e,d,u,v,n,h=f,o=["wheel","mousewheel","DOMMouseScroll"],s="onwheel"in b||9<=b.documentMode?["wheel"]:["mousewheel","DomMouseScroll","MozMousePixelScroll"];if(h.event.fixHooks)for(var i=o.length;i;)h.event.fixHooks[o[--i]]=h.event.mouseHooks;function a(t){var e=t||m.event,o=[].slice.call(arguments,1),s=0,i=0,a=0;return(t=h.event.fix(e)).type="mousewheel",e.wheelDelta&&(s=e.wheelDelta),e.detail&&(s=-1*e.detail),e.deltaY&&(s=a=-1*e.deltaY),e.deltaX&&(s=-1*(i=e.deltaX)),e.wheelDeltaY!==r&&(a=e.wheelDeltaY),e.wheelDeltaX!==r&&(i=-1*e.wheelDeltaX),e=Math.abs(s),(!v||e<v)&&(v=e),e=Math.max(Math.abs(a),Math.abs(i)),(!n||e<n)&&(n=e),o.unshift(t,Math.floor(s/v),Math.floor(i/n),Math.floor(a/n)),(h.event.dispatch||h.event.handle).apply(this,o)}h.event.special.mousewheel={setup:function(){if(this.addEventListener)for(var t=s.length;t;)this.addEventListener(s[--t],a,!1);else this.onmousewheel=a},teardown:function(){if(this.removeEventListener)for(var t=s.length;t;)this.removeEventListener(s[--t],a,!1);else this.onmousewheel=null}},h.fn.extend({mousewheel:function(t){return t?this.bind("mousewheel",t):this.trigger("mousewheel")},unmousewheel:function(t){return this.unbind("mousewheel",t)}});var w=function(t){try{if(t&&"function"==typeof URL){var e=new URL(m.location.href);if("https:"==e.protocol)return(e=new URL(t)).protocol="https:",e.href}}catch(t){}return t},_="ipages-instance",k=0,x=1,p=2;function $(t,e){this.name="TwoPageFlip",this.root=t,this.config=e,this.leftPage=null,this.rightPage=null,this.leftBackPage=null,this.rightBackPage=null,this.leftBelowPage=null,this.rightBelowPage=null,this.$animation=null,this.swipe={startY:0,startX:0,endY:0,endX:0,diffY:0,diffX:0,startTouch:!1,startAngle:0,prevAngle:0,angle:0,angleThreshold:30}}function C(t,e){this.name="OnePageFlip",this.root=t,this.config=e,this.prevPage=null,this.currPage=null,this.nextPage=null,this.$animation=null,this.swipe={startY:0,startX:0,endY:0,endX:0,diffY:0,diffX:0,startTouch:!1,startAngle:0,prevAngle:0,angle:0,angleThreshold:30}}function y(t,e){this.name="OnePageSwipe",this.root=t,this.config=e,this.prevPage=null,this.currPage=null,this.nextPage=null,this.$animation=null,this.swipe={startY:0,startX:0,endY:0,endX:0,diffY:0,diffX:0,startTouch:!1,startOffset:0,prevOffset:0,offset:0,offsetThreshold:30}}function P(t,e){this.id=k++,this.$body=null,this.$container=null,this.$placeholder=null,this.config=null,this.bookWidth=0,this.bookHeight=0,this.pageWidth=0,this.pageHeight=0,this.currPage=0,this.pageIndexPrev=0,this.stagePadding={top:0,left:0,right:0,bottom:0},this.pdf=null,this.pdfPageSize=x,this.pdfPageCount=0,this.pdfFirstPage=null,this.pdfFirstPageViewport=null,this.pdfFirstPageRatio=0,this.pdfPagesRefCache=null,this.pdfAnnotationsRefCache=null,this.matrix=new g,this.lastDelta={x:0,y:0},this.lastScale=0,this.tapped=null,this.zoomTimerId=null,this.pinchZoom={zoom:0,startDate:!1,aStartX:0,aStartY:0,aCurX:0,aCurY:0,aIsMoving:!1,bStartX:0,bStartY:0,bCurX:0,bCurY:0,bIsMoving:!1},this.dragNavigation={target:null,startX:0,startY:0,x:0,y:0},this.thumbnailsScrollTimerId=null,this.thumbnailsScrollTimeout=2e3,this.themeClass=null,this.engineClass=null,this.engine=null,this.ready=!1,this.controls={},this.pages=[],this.bookmarksMap=new Map,this.bookTransitionTimerId=null,this._init(t,e)}$.prototype={_normalizePageIndex:function(t){return!t||t<0?0:t>this.root.pages.length-1?this.root.pages.length-1:t},_isPageLeft:function(t){return!!(t%2)},_isPageRight:function(t){return!this._isPageLeft(t)},_getLeftPageIndex:function(t){return this._isPageRight(t)&&(t+=-1),t<0||t>this.root.pages.length-1?null:t},_getRightPageIndex:function(t){return this._isPageLeft(t)&&(t+=1),t<0||t>this.root.pages.length-1?null:t},_getBackPageIndex:function(t){return!t&&0!=t||(t+=this._isPageLeft(t)?-1:1),t<0||t>this.root.pages.length-1?null:t},_getBelowPageIndex:function(t){return!t&&0!=t||(t+=this._isPageLeft(t)?-2:2),t<0||t>this.root.pages.length-1?null:t},_clearSwipe:function(){this.swipe.startY=0,this.swipe.startX=0,this.swipe.endY=0,this.swipe.endX=0,this.swipe.diffY=0,this.swipe.diffX=0,this.swipe.startAngle=0,this.swipe.prevAngle=0,this.swipe.angle=0,this.swipe.startTouch=!1},_stopAnimation:function(t){this.$animation&&this.$animation.stop(!0,t||!1),this.$animation=null},_setAngle:function(t){t<=-180?t=-180:180<=t&&(t=180);var e,o,s=Math.abs(t),i=(90<s?180-s:s)/200;t<0?null!=this.rightBackPage&&(null!=this.rightBelowPage&&(this.root.pages[this.rightBelowPage].css({display:"block",transform:"","z-index":1}),this.root._setShowHidePageState(this.rightBelowPage,!0)),null!=this.leftBelowPage&&this.root.pages[this.leftBelowPage].css({"z-index":2}),null!=this.leftBackPage&&this.root.pages[this.leftBackPage].css({"z-index":3}),null!=this.leftPage&&this.root.pages[this.leftPage].css({"z-index":4}),90<s?(null!=this.rightPage&&(this.root.pages[this.rightPage].css({display:"none"}),this.root._setShowHidePageState(this.rightPage,!1)),null!=this.rightBackPage&&(this.root.pages[this.rightBackPage].css({display:"block",transform:"rotateY("+(180+t)+"deg) translateZ(0px)","z-index":7}).$shadow.css({opacity:i}),this.root._setShowHidePageState(this.rightBackPage,!0))):(null!=this.rightPage&&(this.root.pages[this.rightPage].css({display:"block",transform:"rotateY("+t+"deg) translateZ(0px)","z-index":7}).$shadow.css({opacity:i}),this.root._setShowHidePageState(this.rightPage,!0)),null!=this.rightBackPage&&(this.root.pages[this.rightBackPage].css({display:"none"}),this.root._setShowHidePageState(this.rightBackPage,!1))),null==this.leftPage?90<s&&(e=1-(s-90)/90,o-=this.root.pageWidth*this.root._getZoom()/2*e,this.root.controls.$book.css({transform:"translateX("+o+"px)"})):null==this.rightBelowPage&&s<90&&(e=1-(90-s)/90,o+=this.root.pageWidth*this.root._getZoom()/2*e,this.root.controls.$book.css({transform:"translateX("+o+"px)"}))):0<=t&&null!=this.leftBackPage&&(null!=this.leftBelowPage&&(this.root.pages[this.leftBelowPage].css({display:"block",transform:"","z-index":1}),this.root._setShowHidePageState(this.leftBelowPage,!0)),null!=this.rightBelowPage&&this.root.pages[this.rightBelowPage].css({"z-index":2}),null!=this.rightBackPage&&this.root.pages[this.rightBackPage].css({"z-index":3}),null!=this.rightPage&&this.root.pages[this.rightPage].css({"z-index":4}),90<s?(null!=this.leftPage&&(this.root.pages[this.leftPage].css({display:"none"}),this.root._setShowHidePageState(this.leftPage,!1)),null!=this.leftBackPage&&(this.root.pages[this.leftBackPage].css({display:"block",transform:"rotateY("+(-180+t)+"deg) translateZ(0px)","z-index":7}).$shadow.css({opacity:i}),this.root._setShowHidePageState(this.leftBackPage,!0))):(null!=this.leftPage&&(this.root.pages[this.leftPage].css({display:"block",transform:"rotateY("+t+"deg) translateZ(0px)","z-index":7}).$shadow.css({opacity:i}),this.root._setShowHidePageState(this.leftPage,!0)),null!=this.leftBackPage&&(this.root.pages[this.leftBackPage].css({display:"none"}),this.root._setShowHidePageState(this.leftBackPage,!1))),null==this.leftBelowPage?s<90&&(e=1-(90-s)/90,o-=this.root.pageWidth*this.root._getZoom()/2*e,this.root.controls.$book.css({transform:"translateX("+o+"px)"})):null==this.rightPage&&90<s&&(e=1-(s-90)/90,o=0,o+=this.root.pageWidth*this.root._getZoom()/2*e,this.root.controls.$book.css({transform:"translateX("+o+"px)"})))},_animateTurnPage:function(t,e){var o=f.Deferred(),s=(this._stopAnimation(),this),i=this.root.config.flipDuration/180*Math.abs(e-t);return this.$animation=f({angle:t}),this.$animation.animate({angle:e},{duration:i,easing:"linear",done:function(){s.swipe.startAngle=0;var t=s.$animation=null;null!=(t=180==e?s.leftBackPage:-180==e?s.rightBackPage:null!=s.leftPage?s.leftPage:null!=s.rightPage?s.rightPage:null)&&s.showPage(t),o.resolve()},fail:function(){o.reject()},step:function(t){s.swipe.startAngle=t,s._setAngle(t)}}),o.promise()},updateBook:function(t){for(var e=!0,o=0,s=this.root.pages.length;o<s;o++){var i=this.root.pages[o];i.toggleClass("ipgs-left",!e).toggleClass("ipgs-right",e).removeClass("ipgs-show").addClass("ipgs-hide"),i.pageLeft=!e,e=!(i.pageRight=e)}t&&this.showPage(this.root.currPage)},updateBookLayout:function(){var t=0;0==this.rightPage?t-=this.root.pageWidth*this.root._getZoom()/2:this.leftPage==this.root.pages.length-1&&(t+=this.root.pageWidth*this.root._getZoom()/2),this.root.controls.$book.css({transform:"translateX("+t+"px)"});for(var e=0,o=this.root.pages.length;e<o;e++){var s=this.root.pages[e];s.css({left:s.pageRight?this.root.pageWidth*this.root._getZoom()-1:0})}},showPage:function(t){t=this._normalizePageIndex(t);var e=this._getLeftPageIndex(t),o=this._getRightPageIndex(t),s=this._getBackPageIndex(e),i=this._getBackPageIndex(o),a=this._getBelowPageIndex(e),n=this._getBelowPageIndex(o);this.root._loadPageData(e),this.root._loadPageData(o),this.root.config.preloadNeighbours&&(this.root._loadPageData(s),this.root._loadPageData(i),this.root._loadPageData(a),this.root._loadPageData(n));for(var h=0,l=this.root.pages.length;h<l;h++){var r=this.root.pages[h],g="none",p=0,c=!1;h!=e&&h!=o||(g="block",p=1,c=!0),r.css({display:g,top:0,left:r.pageRight?this.root.pageWidth*this.root._getZoom():0,transform:"","z-index":p}),this.root._setShowHidePageState(h,c)}this.root.currPage=t,this.leftPage=e,this.rightPage=o,this.leftBackPage=s,this.rightBackPage=i,this.leftBelowPage=a,this.rightBelowPage=n,null!=this.leftPage&&this.root.pages[this.leftPage].$shadow.css({opacity:0}),null!=this.leftBackPage&&this.root.pages[this.leftBackPage].$shadow.css({opacity:0}),null!=this.leftBelowPage&&this.root.pages[this.leftBelowPage].$shadow.css({opacity:0}),null!=this.rightPage&&this.root.pages[this.rightPage].$shadow.css({opacity:0}),null!=this.rightBackPage&&this.root.pages[this.rightBackPage].$shadow.css({opacity:0}),null!=this.rightBelowPage&&this.root.pages[this.rightBelowPage].$shadow.css({opacity:0}),this.updateBookLayout(),this.root._onShowPage(t)},gotoPage:function(t){var e;this._stopAnimation(!0),t=this._normalizePageIndex(t),this.leftPage!=t&&this.rightPage!=t&&((e=(t=t)<this.root.currPage?180:-180)<0?(null!=this.rightBackPage&&this.root.pages[this.rightBackPage].css({display:"none",transform:"","z-index":0}),null!=this.rightBelowPage&&this.root.pages[this.rightBelowPage].css({display:"none",transform:"","z-index":0}),this._isPageLeft(t)?(this.rightBackPage=t,this.rightBelowPage=this._getRightPageIndex(t)):(this.rightBackPage=this._getLeftPageIndex(t),this.rightBelowPage=t)):(null!=this.leftBackPage&&this.root.pages[this.leftBackPage].css({display:"none",transform:"","z-index":0}),null!=this.leftBelowPage&&this.root.pages[this.leftBelowPage].css({display:"none",transform:"","z-index":0}),this._isPageRight(t)?(this.leftBackPage=t,this.leftBelowPage=this._getLeftPageIndex(t)):(this.leftBackPage=this._getRightPageIndex(t),this.leftBelowPage=t)),this._animateTurnPage(0,e))},gotoNext:function(){null!=this.rightBackPage&&this.gotoPage(this.rightBackPage)},gotoPrev:function(){null!=this.leftBackPage&&this.gotoPage(this.leftBackPage)},onSwipeDown:function(t){this.swipe.startY=this.swipe.endY=t.pageY,this.swipe.startX=this.swipe.endX=t.pageX,this.swipe.startTouch=!0,this._stopAnimation(),this.swipe.prevAngle=this.swipe.angle,this.swipe.angle=this.swipe.startAngle},onSwipeMove:function(t){this.swipe.startTouch&&(this.swipe.endY=t.pageY,this.swipe.endX=t.pageX,this.swipe.diffY=this.swipe.endY-this.swipe.startY,this.swipe.diffX=this.swipe.endX-this.swipe.startX,this.swipe.prevAngle=this.swipe.angle,this.swipe.angle=this.swipe.startAngle+this.swipe.diffX/(this.root.controls.$bookWrap.width()/2)*180,this._setAngle(this.swipe.angle))},onSwipeUp:function(t){var e,o;this.swipe.startTouch&&(this.swipe.startTouch=!1,e=this.swipe.angle,(o=(o=Math.abs(this.swipe.angle)<this.swipe.angleThreshold?0:this.swipe.angle<0?-180:180)<0&&0<this.swipe.angle-this.swipe.prevAngle||0<o&&this.swipe.angle-this.swipe.prevAngle<0?0:o)==e||0<o&&null==this.leftPage||o<0&&null==this.rightPage?this._clearSwipe():this._animateTurnPage(e,o).always(function(){}))}},C.prototype={_normalizePageIndex:function(t){return!t||t<0?0:t>this.root.pages.length-1?this.root.pages.length-1:t},_getPrevPageIndex:function(t){return!t&&0!=t||--t,t<0||t>this.root.pages.length-1?null:t},_getNextPageIndex:function(t){return!t&&0!=t||(t+=1),t<0||t>this.root.pages.length-1?null:t},_clearSwipe:function(){this.swipe.startY=0,this.swipe.startX=0,this.swipe.endY=0,this.swipe.endX=0,this.swipe.diffY=0,this.swipe.diffX=0,this.swipe.startAngle=0,this.swipe.prevAngle=0,this.swipe.angle=0,this.swipe.startTouch=!1},_stopAnimation:function(t){this.$animation&&this.$animation.stop(!0,t||!1),this.$animation=null},_setAngle:function(t){t<=-90?t=-90:90<=t&&(t=90);Math.abs(t);t<0?null!=this.nextPage&&(null!=this.prevPage&&(this.root.pages[this.prevPage].css({display:"none"}),this.root._setShowHidePageState(this.prevPage,!1)),null!=this.currPage&&(this.root.pages[this.currPage].css({display:"block",transform:"rotateY("+t+"deg) translateZ(0px)","z-index":2}).$shadow.css({opacity:0}),this.root._setShowHidePageState(this.currPage,!0)),null!=this.nextPage&&(this.root.pages[this.nextPage].css({display:"block",transform:"","z-index":1}),this.root._setShowHidePageState(this.nextPage,!0))):0<=t&&null!=this.prevPage&&(null!=this.prevPage&&(this.root.pages[this.prevPage].css({display:"block",transform:"rotateY("+(-90+t)+"deg) translateZ(0px)","z-index":2}).$shadow.css({opacity:0}),this.root._setShowHidePageState(this.prevPage,!0)),null!=this.currPage&&(this.root.pages[this.currPage].css({display:"block",transform:"","z-index":1}),this.root._setShowHidePageState(this.currPage,!0)),null!=this.nextPage&&(this.root.pages[this.nextPage].css({display:"none"}),this.root._setShowHidePageState(this.nextPage,!1)))},_animateTurnPage:function(t,e){var o=f.Deferred(),s=(this._stopAnimation(),this),i=this.root.config.flipDuration/90*Math.abs(e-t);return this.$animation=f({angle:t}),this.$animation.animate({angle:e},{duration:i,easing:"linear",done:function(){s.swipe.startAngle=0;var t=s.$animation=null;null!=(t=90==e?s.prevPage:-90==e?s.nextPage:null!=s.currPage?s.currPage:null)&&s.showPage(t),o.resolve()},fail:function(){o.reject()},step:function(t){s.swipe.startAngle=t,s._setAngle(t)}}),o.promise()},updateBook:function(t){for(var e=0,o=this.root.pages.length;e<o;e++){var s=this.root.pages[e];s.toggleClass("ipgs-right",!0).removeClass("ipgs-show").addClass("ipgs-hide"),s.pageIndex=e}t&&this.showPage(this.root.currPage)},updateBookLayout:function(){},showPage:function(t){var e=t=this._normalizePageIndex(t),o=this._getPrevPageIndex(e),s=this._getNextPageIndex(e);this.root._loadPageData(e),this.root.config.preloadNeighbours&&(this.root._loadPageData(o),this.root._loadPageData(s));for(var i=0,a=this.root.pages.length;i<a;i++){var n="none",h=0,r=!1;i==e&&(n="block",h=1,r=!0),this.root.pages[i].css({display:n,top:0,left:0,transform:"","z-index":h}),this.root._setShowHidePageState(i,r)}this.root.currPage=t,this.currPage=e,this.prevPage=o,this.nextPage=s,null!=this.currPage&&this.root.pages[this.currPage].$shadow.css({opacity:0}),null!=this.prevPage&&this.root.pages[this.prevPage].$shadow.css({opacity:0}),null!=this.nextPage&&this.root.pages[this.nextPage].$shadow.css({opacity:0}),this.updateBookLayout(),this.root._onShowPage(t)},gotoPage:function(t){var e;this._stopAnimation(!0),t=this._normalizePageIndex(t),this.currPage!=t&&((e=(t=t)<this.currPage?90:-90)<0?(null!=this.prevPage&&this.root.pages[this.prevPage].css({display:"none",transform:"","z-index":0}),this.nextPage=t):(null!=this.nextPage&&this.root.pages[this.nextPage].css({display:"none",transform:"","z-index":0}),this.prevPage=t),this._animateTurnPage(0,e))},gotoNext:function(){null!=this.nextPage&&this.gotoPage(this.nextPage)},gotoPrev:function(){null!=this.prevPage&&this.gotoPage(this.prevPage)},onSwipeDown:function(t){this.swipe.startY=this.swipe.endY=t.pageY,this.swipe.startX=this.swipe.endX=t.pageX,this.swipe.startTouch=!0,this._stopAnimation(),this.swipe.prevAngle=this.swipe.angle,this.swipe.angle=this.swipe.startAngle},onSwipeMove:function(t){this.swipe.startTouch&&(this.swipe.endY=t.pageY,this.swipe.endX=t.pageX,this.swipe.diffY=this.swipe.endY-this.swipe.startY,this.swipe.diffX=this.swipe.endX-this.swipe.startX,this.swipe.prevAngle=this.swipe.angle,this.swipe.angle=this.swipe.startAngle+this.swipe.diffX/this.root.controls.$bookWrap.width()*180,this._setAngle(this.swipe.angle))},onSwipeUp:function(t){var e,o;this.swipe.startTouch&&(this.swipe.startTouch=!1,e=this.swipe.angle,(o=(o=Math.abs(this.swipe.angle)<this.swipe.angleThreshold?0:this.swipe.angle<0?-90:90)<0&&0<this.swipe.angle-this.swipe.prevAngle||0<o&&this.swipe.angle-this.swipe.prevAngle<0?0:o)==e||0<o&&null==this.prevPage||o<0&&null==this.nextPage?this._clearSwipe():this._animateTurnPage(e,o).always(function(){}))}},P.prototype={VERSION:"1.4.3",defaultConfig:{bookEngine:"TwoPageFlip",bookEnginePortrait:null,bookEngineLandscape:null,ratioPortraitToLandscape:1.3,bookTheme:"default",pageWidth:300,pageHeight:360,pageSizeAuto:!0,pageStart:1,pageStartDelay:0,pdfUrl:null,pdfAutoLoad:!0,pdfCoverImageUrl:null,pdfAutoCreatePages:!(y.prototype={_normalizePageIndex:function(t){return!t||t<0?0:t>this.root.pages.length-1?this.root.pages.length-1:t},_getPrevPageIndex:function(t){return!t&&0!=t||--t,t<0||t>this.root.pages.length-1?null:t},_getNextPageIndex:function(t){return!t&&0!=t||(t+=1),t<0||t>this.root.pages.length-1?null:t},_clearSwipe:function(){this.swipe.startY=0,this.swipe.startX=0,this.swipe.endY=0,this.swipe.endX=0,this.swipe.diffY=0,this.swipe.diffX=0,this.swipe.startOffset=0,this.swipe.prevOffset=0,this.swipe.offset=0,this.swipe.startTouch=!1},_stopAnimation:function(t){this.$animation&&this.$animation.stop(!0,t||!1),this.$animation=null},_setOffset:function(t){t<=-50?t=-50:50<=t&&(t=50);var e=this.root.controls.$book.width(),e=this.root.controls.$bookWrap.width()/e;this.root.config.autoFit||this.root.config.responsive&&e<1||(e=1);var e=(this.root.$container.width()/2+this.root.pageWidth*e/2)/e,o=this.config.pageFade?Math.abs(t)/50:1,s=this.config.pageFade?1-o:1;(t=e*t/50)<0?null!=this.nextPage&&(null!=this.prevPage&&(this.root.pages[this.prevPage].css({display:"none"}),this.root._setShowHidePageState(this.prevPage,!1)),null!=this.currPage&&(this.root.pages[this.currPage].css({display:"block",transform:"translateX("+t+"px) translateZ(0px)","z-index":2,opacity:s}),this.root._setShowHidePageState(this.currPage,!0)),null!=this.nextPage&&(this.root.pages[this.nextPage].css({display:"block",transform:"translateX("+(e+t)+"px) translateZ(0px)","z-index":1,opacity:o}),this.root._setShowHidePageState(this.nextPage,!0))):0<=t&&null!=this.prevPage&&(null!=this.prevPage&&(this.root.pages[this.prevPage].css({display:"block",transform:"translateX("+(-e+t)+"px) translateZ(0px)","z-index":1,opacity:o}),this.root._setShowHidePageState(this.prevPage,!0)),null!=this.currPage&&(this.root.pages[this.currPage].css({display:"block",transform:"translateX("+t+"px) translateZ(0px)","z-index":2,opacity:s}),this.root._setShowHidePageState(this.currPage,!0)),null!=this.nextPage&&(this.root.pages[this.nextPage].css({display:"none"}),this.root._setShowHidePageState(this.nextPage,!1)))},_animateSwipePage:function(t,e){var o=f.Deferred(),s=(this._stopAnimation(),this),i=this.root.config.flipDuration/90*Math.abs(e-t);return this.$animation=f({offset:t}),this.$animation.animate({offset:e},{duration:i,easing:"linear",done:function(){s.swipe.startOffset=0;var t=s.$animation=null;null!=(t=50==e?s.prevPage:-50==e?s.nextPage:null!=s.currPage?s.currPage:null)&&s.showPage(t),o.resolve()},fail:function(){o.reject()},step:function(t){s.swipe.startOffset=t,s._setOffset(t)}}),o.promise()},updateBook:function(t){for(var e=0,o=this.root.pages.length;e<o;e++){var s=this.root.pages[e];s.removeClass("ipgs-show").addClass("ipgs-hide"),s.pageIndex=e}t&&this.showPage(this.root.currPage)},updateBookLayout:function(){},showPage:function(t){var e=t=this._normalizePageIndex(t),o=this._getPrevPageIndex(e),s=this._getNextPageIndex(e);this.root._loadPageData(e),this.root.config.preloadNeighbours&&(this.root._loadPageData(o),this.root._loadPageData(s));for(var i=0,a=this.root.pages.length;i<a;i++){var n="none",h=0,r=!1;i==e&&(n="block",h=1,r=!0),this.root.pages[i].css({display:n,top:0,left:0,transform:"",opacity:"","z-index":h}),this.root._setShowHidePageState(i,r)}this.root.currPage=t,this.currPage=e,this.prevPage=o,this.nextPage=s,null!=this.currPage&&this.root.pages[this.currPage].$shadow.css({opacity:0}),null!=this.prevPage&&this.root.pages[this.prevPage].$shadow.css({opacity:0}),null!=this.nextPage&&this.root.pages[this.nextPage].$shadow.css({opacity:0}),this.updateBookLayout(),this.root._onShowPage(t)},gotoPage:function(t){var e;this._stopAnimation(!0),t=this._normalizePageIndex(t),this.currPage!=t&&((e=(t=t)<this.currPage?50:-50)<0?(null!=this.prevPage&&this.root.pages[this.prevPage].css({display:"none",transform:"","z-index":0}),this.nextPage=t):(null!=this.nextPage&&this.root.pages[this.nextPage].css({display:"none",transform:"","z-index":0}),this.prevPage=t),this._animateSwipePage(0,e))},gotoNext:function(){null!=this.nextPage&&this.gotoPage(this.nextPage)},gotoPrev:function(){null!=this.prevPage&&this.gotoPage(this.prevPage)},onSwipeDown:function(t){this.swipe.startY=this.swipe.endY=t.pageY,this.swipe.startX=this.swipe.endX=t.pageX,this.swipe.startTouch=!0,this._stopAnimation(),this.swipe.prevOffset=this.swipe.offset,this.swipe.offset=this.swipe.startOffset},onSwipeMove:function(t){this.swipe.startTouch&&(this.swipe.endY=t.pageY,this.swipe.endX=t.pageX,this.swipe.diffY=this.swipe.endY-this.swipe.startY,this.swipe.diffX=this.swipe.endX-this.swipe.startX,this.swipe.prevOffset=this.swipe.offset,this.swipe.offset=this.swipe.startOffset+this.swipe.diffX/this.root.controls.$bookWrap.width()*100,this._setOffset(this.swipe.offset))},onSwipeUp:function(t){var e,o;this.swipe.startTouch&&(this.swipe.startTouch=!1,o=(this.root.controls.$bookWrap.width()/2+this.root.pageWidth/2)*this.swipe.offset/50,e=this.swipe.offset,(o=(o=Math.abs(o)<this.swipe.offsetThreshold?0:this.swipe.offset<0?-50:50)<0&&0<this.swipe.offset-this.swipe.prevOffset||0<o&&this.swipe.offset-this.swipe.prevOffset<0?0:o)==e||0<o&&null==this.prevPage||o<0&&null==this.nextPage?this._clearSwipe():this._animateSwipePage(e,o).always(function(){}))}}),pdfDisableRangeRequests:!0,preloadNeighbours:!1,responsive:!0,autoFit:!0,autoHeight:!1,flipSound:!1,flipSoundUrl:null,perspective:1500,padding:{top:10,right:10,bottom:10,left:10},flipDuration:300,pageNumbers:!0,pageNumbersFirst:1,pageNumbersHidden:[],pageImagesUrl:null,pageImagesFirst:1,pageImagesCount:0,prevnextButtons:!0,touchNavigation:!0,keyboardNavigation:!0,mouseDragNavigation:!0,mousePageClickNavigation:!1,mouseWheelNavigation:!1,mouseWheelPreventDefault:!0,zoom:1,zoomMax:7,zoomMin:1,zoomStep:.05,zoomFocal:!0,dblClickZoomDefault:!1,mouseWheelZoom:!0,keyboardZoom:!0,pinchZoom:!0,pinchZoomCoef:.005,toolbar:!0,toolbarControls:[{type:"share",active:!0,title:"share",icon:"ipgs-icon-share"},{type:"outline",active:!0,title:"toggle outline/bookmarks",icon:"ipgs-icon-outline"},{type:"thumbnails",active:!0,title:"toggle thumbnails",icon:"ipgs-icon-thumbnails"},{type:"sound",active:!0,title:"turn on/off flip sound",icon:"ipgs-icon-sound"},{type:"gotofirst",active:!0,title:"goto first page",icon:"ipgs-icon-gotofirst"},{type:"prev",active:!0,title:"prev page",icon:"ipgs-icon-prev"},{type:"pagenumber",active:!0,title:"goto page number",icon:"ipgs-icon-pagenumber"},{type:"next",active:!0,title:"next page",icon:"ipgs-icon-next"},{type:"gotolast",active:!0,title:"goto last page",icon:"ipgs-icon-gotolast"},{type:"download",active:!1,title:"download pdf",icon:"ipgs-icon-download"},{type:"zoom-in",active:!0,title:"zoom in",icon:"ipgs-icon-zoom-in"},{type:"zoom-out",active:!0,title:"zoom out",icon:"ipgs-icon-zoom-out"},{type:"zoom-default",active:!0,title:"zoom default",icon:"ipgs-icon-zoom-default"},{type:"fullscreen",active:!0,title:"toggle fullscreen",icon:"ipgs-icon-fullscreen"}],autoEnableThumbnails:!1,autoEnableOutline:!1,autoEnableShare:!1,pages:[],bookmarks:[],shareControls:[{type:"facebook",active:!0,title:"facebook",icon:"ipgs-share-icon-facebook"},{type:"twitter",active:!0,title:"twitter",icon:"ipgs-share-icon-twitter"},{type:"linkedin",active:!0,title:"linkedin",icon:"ipgs-share-icon-linkedin"},{type:"email",active:!0,title:"email",icon:"ipgs-share-icon-email"}],twoPageFlip:{},onePageFlip:{},onePageSwipe:{pageFade:!0},onLoad:null,txtConfigFileFailedToLoad:"Failed to load a config file",txtFailedEngine:"Can not find the book engine module specified",txtPDFLoading:"Loading PDF document",txtPDFFailedToLoad:"Failed to load PDF document",txtShareDlgTitle:"Share",contextmenu:!1},defaultPage:{type:"image",image:null,page:0},touchMouseEvent:{down:"touchmousedown",up:"touchmouseup",move:"touchmousemove"},$body:null,_init:function(t,e){var o;e.pdfUrl=w(e.pdfUrl),e.pdfCoverImageUrl=w(e.pdfCoverImageUrl),e.flipSoundUrl=w(e.flipSoundUrl),this.$body=f("body"),this.$container=t,this.config=e,this.themeClass=e.bookTheme?"ipgs-theme-"+e.bookTheme.toLowerCase():null,this._buildDOM(),this.config.pdfUrl&&!this.config.pdfAutoLoad?((o=this).controls.$bookCover.addClass("ipgs-active"),o.controls.$bookCover.one("click",function(t){o.controls.$stage.trigger("click")}),o.controls.$stage.one("click",function(t){o._create()})):this._create()},_create:function(){this.controls.$bookLoading.addClass("ipgs-active");var t,o=this;function s(){switch(o.controls.$bookCover.removeClass("ipgs-active"),o.pageWidth=o.config.pageWidth,o.pageHeight=o.config.pageHeight,o.bookHeight=o.config.pageHeight,o.engineClass="ipgs-"+o.config.bookEngine.toLowerCase(),o.engine=null,o.engineClass){case"ipgs-twopageflip":o.bookWidth=2*o.config.pageWidth,o.engine=new $(o,f.extend(!0,{},o.config.twoPageFlip));break;case"ipgs-onepageflip":o.bookWidth=o.config.pageWidth,o.engine=new C(o,f.extend(!0,{},o.config.onePageFlip));break;case"ipgs-onepageswipe":o.bookWidth=o.config.pageWidth,o.engine=new y(o,f.extend(!0,{},o.config.onePageSwipe));break;default:return console.error(o.config.txtFailedEngine+" ["+o.engineClass+"]"),void o._updateLoadingInfo(o.config.txtFailedEngine)}o.controls.$book.css({width:o.bookWidth,height:o.bookHeight}),o._initPages(),o._initThumbnails(),o._initBookmarks(),o._setZoom({zoom:o.config.zoom},!0,!0),o._updateSize(),o._updateBookEngine(),o._ready()}function e(t){var e=new Image;e.onload=function(){o.config.pageWidth=parseInt(e.width,10),o.config.pageHeight=parseInt(e.height,10),s()},e.onerror=function(){s()},e.src=t}this.config.pdfUrl?(PDFJS.disableAutoFetch=!0,PDFJS.disableStream=!0,PDFJS.disableRange=o.config.pdfDisableRangeRequests,PDFJS.externalLinkTarget=PDFJS.LinkTarget.BLANK,(t=PDFJS.getDocument(this.config.pdfUrl)).then(function(t){o.pdf=t,o.pdfPageSize=x,o.pdfPageCount=t.numPages,o.pdfFirstPage=null,o.pdfFirstPageViewport=null,o.pdfFirstPageRatio=0,o.pdfPagesRefCache=null,o.pdfAnnotationsRefCache=null,o.pdf.getPage(1).then(function(t){o.pdfFirstPage=t,o.pdfFirstPageViewport=t.getViewport(1),o.pdfFirstPageRatio=o.pdfFirstPageViewport.width/o.pdfFirstPageViewport.height,o.pdfPagesRefCache=Object.create(null),o.pdfAnnotationsRefCache=Object.create(null),o.config.pageSizeAuto&&(o.config.pageWidth=parseInt(o.pdfFirstPageViewport.width,10),o.config.pageHeight=parseInt(o.pdfFirstPageViewport.height,10)),1<o.pdf.numPages?o.pdf.getPage(2).then(function(t){t=t.getViewport(1);t.width/t.height>1.5*o.pdfFirstPageRatio&&(o.pdfPageSize=p,o.pdfPageCount=2*o.pdfPageCount-2),s()}):s()},function(){s()})},function(t){console.error(t.message),o._updateLoadingInfo(o.config.txtPDFFailedToLoad)}),t.onProgress=function(t){var e=100*t.loaded/t.total;isNaN(e)?t&&t.loaded?o._updateLoadingInfo(o.config.txtPDFLoading+" "+(Math.ceil(t.loaded/1e4)/100).toString()+"Mb"):o._updateLoadingInfo(o.config.txtPDFLoading):o._updateLoadingInfo(o.config.txtPDFLoading+" "+e.toString().split(".")[0]+"%")}):this.config.pageSizeAuto?(t=this.$container.find(".ipgs-pages > [data-image]")).length?e(t.data("image")):this.config.pageImagesUrl?e(this._replaceNumberTemplate(this.config.pageImagesUrl,this.config.pageImagesFirst)):this.config.pages.length&&"image"==this.config.pages[0].type&&this.config.pages[0].image?e(this.config.pages[0].image):s():s()},_ready:function(){console.log("IPAGES: version "+this.VERSION),this._bind(),this.$container.find(".ipgs-message").remove(),this.config.jsonFail&&(t=f("<div>").addClass("ipgs-message").text(this.config.txtConfigFileFailedToLoad+' "'+this.config.jsonUrl+'"'),this.$container.append(t)),this.config.pageStart=this.$container.data("wp-page-start")?this.$container.data("wp-page-start"):this.config.pageStart;var t=this.getQueryParameters(),t=t.page||t.pagenum;if(t&&(this.config.pageStart=t),this.config.pageStart=this.config.pageStart||this.$container.data("page-start"),this.config.onLoad){t=null;if("string"==typeof this.config.onLoad)try{t=new Function(this.config.onLoad)}catch(t){console.error("Can not compile onLoad function: "+t.message)}else"function"==typeof this.config.onLoad&&(t=this.config.onLoad);t&&t.call(this)}this.controls.$bookCover.removeClass("ipgs-active"),this.controls.$book.addClass("ipgs-no-transition"),this.$container.addClass("ipgs-ready"),this.ready=!0,this.$container.trigger("ipages:ready",[this]);var e=this,t=(setTimeout(function(){e.controls.$book.removeClass("ipgs-no-transition")},1),this.config.flipSound);this.config.flipSound=!1,0<this.config.pageStartDelay?(this._showPage(0),this.pageStartTimerId=setTimeout(f.proxy(function(){this._gotoPage(this.config.pageStart-1)},this),this.config.pageStartDelay)):this._showPage(this.config.pageStart-1),this.config.flipSound=t,this.config.toolbar&&(this.config.autoEnableThumbnails&&this._onToggleThumbnails(),this.config.autoEnableOutline&&this._onToggleOutline(),this.config.autoEnableShare&&this._onToggleShare())},_buildDOM:function(){this.$container.addClass("ipgs").addClass(this.engineClass).addClass(this.themeClass),this.$container.wrapInner(f("<div>").addClass("ipgs-pages").css("display","none")),this.controls.$placeholder=f("<div>").addClass("ipgs-placeholder").css({display:"none"}),this.controls.$stage=f("<div>").addClass("ipgs-stage").attr("tabindex","1"),this.controls.$audio=f("<audio preload></audio>").addClass("ipgs-audio"),this.controls.$prevBtn=f("<div>").addClass("ipgs-prev-page"),this.controls.$nextBtn=f("<div>").addClass("ipgs-next-page"),this.controls.$stageMove=f("<div>").addClass("ipgs-stage-move"),this.controls.$bookCover=f("<div>").addClass("ipgs-book-cover"),this.controls.$bookLoading=f("<div>").addClass("ipgs-book-loading"),this.controls.$bookLoadingInfo=f("<div>").addClass("ipgs-book-loading-info"),this.controls.$bookTransform=f("<div>").addClass("ipgs-book-transform"),this.controls.$bookWrap=f("<div>").addClass("ipgs-book-wrap"),this.controls.$bookSize=f("<div>").addClass("ipgs-book-size"),this.controls.$book=f("<div>").addClass("ipgs-book").css({perspective:this.config.perspective}),this.config.flipSoundUrl&&this.controls.$audio.append(f('<source src="'+this.config.flipSoundUrl+'">')),this.config.pdfCoverImageUrl&&this.controls.$bookCover.append(f('<img src="'+this.config.pdfCoverImageUrl+'">')),this.controls.$bookSize.append(this.controls.$book),this.controls.$bookTransform.append(this.controls.$bookWrap),this.controls.$bookWrap.append(this.controls.$bookSize),this.controls.$stage.append(this.controls.$bookTransform,this.controls.$stageMove),this.controls.$contextmenu=f("<ul>").addClass("ipgs-contextmenu");var t=f("<li>"),e=f("<a>").attr({href:"https://1.envato.market/5QrNo",target:"_blank"}).text("iPages Flipbook");this.controls.$contextmenu.append(t.append(e)),this._updateStagePadding(this.config.padding),this.$container.append(this.controls.$stage,this.controls.$audio),this.config.prevnextButtons&&this.$container.append(this.controls.$prevBtn,this.controls.$nextBtn),this._buildToolbarDOM(),this.$container.append(this.controls.$bookCover,this.controls.$bookLoading,this.controls.$bookLoadingInfo,this.controls.$contextmenu),this.$container.is(":hidden")&&this.$container.css("display","block")},_updateStagePadding:function(t){"number"==typeof t?(this.stagePadding.top=t,this.stagePadding.right=t,this.stagePadding.bottom=t,this.stagePadding.left=t):(this.stagePadding.top=t.hasOwnProperty("top")?t.top:0,this.stagePadding.right=t.hasOwnProperty("right")?t.right:0,this.stagePadding.bottom=t.hasOwnProperty("bottom")?t.bottom:0,this.stagePadding.left=t.hasOwnProperty("left")?t.left:0)},_buildToolbarDOM:function(){if(this.config.toolbar){this.controls.$toolbar=f("<div>").addClass("ipgs-toolbar"),this.controls.toolbar={};for(var t=[],e=0;e<this.config.toolbarControls.length;e++){var o=this.config.toolbarControls[e],s=f("<i></i>").addClass(o.icon),i=f("<div>").addClass("ipgs-control").addClass("ipgs-control-"+o.type).addClass(o.active?"":"ipgs-hidden").attr("title",o.title).append(s);switch(i.on("click",f.proxy(this._onToolbarControlClick,this)),o.type){case"gotofirst":(this.controls.toolbar.$gotofirst=i).on("click",f.proxy(this._onPageFirst,this));break;case"prev":(this.controls.toolbar.$prev=i).on("click",f.proxy(this._onPagePrev,this));break;case"pagenumber":this.controls.toolbar.$pagenumber=i,this.controls.toolbar.$pagenumber.empty(),this.controls.toolbar.$pagenumberLabel=f("<span></span>").addClass("ipgs-pagenumber-label"),this.controls.toolbar.$pagenumberInput=f("<input>").addClass("ipgs-pagenumber-input").attr("type","text"),this.controls.toolbar.$pagenumberLabel.on("click",f.proxy(this._onPageNumberLabelClick,this)),this.controls.toolbar.$pagenumberInput.on("click",f.proxy(this._onPageNumberInputClick,this)),this.controls.toolbar.$pagenumberInput.on("keyup",f.proxy(this._onPageNumberInputKeyup,this)),this.controls.toolbar.$pagenumber.append(this.controls.toolbar.$pagenumberLabel,this.controls.toolbar.$pagenumberInput);break;case"next":(this.controls.toolbar.$next=i).on("click",f.proxy(this._onPageNext,this));break;case"gotolast":(this.controls.toolbar.$gotolast=i).on("click",f.proxy(this._onPageLast,this));break;case"outline":this.controls.$outline=f("<div>").addClass("ipgs-outline"),this.controls.$outlineToggle=f("<div>").addClass("ipgs-outline-toggle"),this.$container.append(this.controls.$outline.append(this.controls.$outlineToggle)),this.controls.$outline.on("click",".ipgs-bookmark",f.proxy(this._onBookmarkClick,this)),(this.controls.toolbar.$outline=i).on("click",f.proxy(this._onToggleOutline,this)),this.controls.$outlineToggle.on("click",f.proxy(this._onToggleOutline,this));break;case"thumbnails":this.controls.$thumbnails=f("<div>").addClass("ipgs-thumbnails"),this.controls.$thumbnailsToggle=f("<div>").addClass("ipgs-thumbnails-toggle"),this.controls.$thumbsWrap=f("<div>").addClass("ipgs-thumbs-wrap"),this.controls.$thumbnails.append(this.controls.$thumbnailsToggle,this.controls.$thumbsWrap),this.$container.append(this.controls.$thumbnails),this.controls.$thumbnails.on("click",".ipgs-thumb",f.proxy(this._onThumbClick,this)),(this.controls.toolbar.$thumbnails=i).on("click",f.proxy(this._onToggleThumbnails,this)),this.controls.$thumbnailsToggle.on("click",f.proxy(this._onToggleThumbnails,this)),this.controls.$thumbsWrap.on("scroll",f.proxy(this._onThumbnailsScroll,this));break;case"zoom-in":(this.controls.toolbar.$zoomin=i).on("mousedown touchstart",f.proxy(this._onZoomIn,this));break;case"zoom-out":(this.controls.toolbar.$zoomout=i).on("mousedown touchstart",f.proxy(this._onZoomOut,this));break;case"zoom-default":(this.controls.toolbar.$zoomdefault=i).on("click",f.proxy(this._onZoomDefault,this));break;case"fullscreen":(this.controls.toolbar.$fullscreen=i).on("click",f.proxy(this._onToggleFullscreen,this));break;case"share":this.controls.$share=f("<div>").addClass("ipgs-share"),this.controls.$shareDialog=f("<div>").addClass("ipgs-share-dialog"),this.controls.$shareHeader=f("<div>").addClass("ipgs-share-header").html(this.config.txtShareDlgTitle),this.controls.$shareControls=f("<div>").addClass("ipgs-share-controls");for(var a=0;a<this.config.shareControls.length;a++){var n,h=this.config.shareControls[a];h.active&&(n=f("<i></i>").addClass(h.icon),n=f("<div>").addClass("ipgs-share-control-"+o.type).attr("title",h.title).append(n),this.controls.$shareControls.append(n),n.on("click",f.proxy(this._onShareClick,this,h.type)))}this.controls.$shareDialog.append(this.controls.$shareHeader,this.controls.$shareControls),this.controls.$share.append(this.controls.$shareDialog),this.$container.append(this.controls.$share),this.controls.$share.on("click",f.proxy(this._onToggleShare,this)),(this.controls.toolbar.$share=i).on("click",f.proxy(this._onToggleShare,this));break;case"download":(this.controls.toolbar.$download=i).on("click",f.proxy(this._onDownload,this));break;case"sound":this.controls.toolbar.$sound=i,this.controls.toolbar.$sound.toggleClass("ipgs-disable",!this.config.flipSound),i.on("click",f.proxy(this._onToggleSound,this))}t.push(i)}for(e=0;e<t.length;e++)this.controls.$toolbar.append(t[e]);this.$container.append(this.controls.$toolbar)}},_bind:function(){this.controls.$stage.on("click touchend",".ipgs-annotation",f.proxy(this._onAnnotationClick,this)),"ontouchstart"in m&&this.config.touchNavigation&&(this.controls.$stage.on("touchstart",f.proxy(this._onBookTouch,this)),this.controls.$stage.on("touchmove",f.proxy(this._onBookTouch,this)),this.controls.$stage.on("touchend",f.proxy(this._onBookTouch,this))),this.config.mouseDragNavigation&&this.controls.$stage.on("mousedown",f.proxy(this._onBookMouse,this)),this.controls.$stage.on(this.touchMouseEvent.down,f.proxy(this._onSwipeDown,this)),this.controls.$stage.on(this.touchMouseEvent.move,f.proxy(this._onSwipeMove,this)),this.controls.$stage.on(this.touchMouseEvent.up,f.proxy(this._onSwipeUp,this)),this.config.mousePageClickNavigation&&this.controls.$stage.on("click",f.proxy(this._onBookMouseClick,this)),this.config.mouseWheelNavigation&&this.controls.$stage.on("mousewheel",f.proxy(this._onMouseWheelNavigation,this)),this.config.keyboardNavigation&&this.controls.$stage.on("keydown",f.proxy(this._onKeyboardNavigation,this)),this.config.dblClickZoomDefault&&(this.controls.$stage.on("dblclick",f.proxy(this._onDblClickZoomDefault,this)),this.controls.$stage.on("touchstart",f.proxy(this._onDblTapZoomDefault,this))),this.config.mouseWheelZoom&&this.controls.$stage.on("mousewheel",f.proxy(this._onMouseWheelZoom,this)),this.config.keyboardZoom&&this.controls.$stage.on("keydown",f.proxy(this._onKeyboardZoom,this)),this.config.pinchZoom&&(this.controls.$stage.on("touchstart",f.proxy(this._onPinchZoomTouchStart,this)),this.controls.$stage.on("touchend",f.proxy(this._onPinchZoomTouchEnd,this))),this.config.prevnextButtons&&(this.controls.$prevBtn.on("click",f.proxy(this._onPrevBtnClick,this)),this.controls.$nextBtn.on("click",f.proxy(this._onNextBtnClick,this))),(this.config.bookEngineLandscape||this.config.bookEnginePortrait)&&f(m).on("orientationchange",f.proxy(this._onOrientationChange,this)),f(m).on("resize",f.proxy(this._onResize,this)),f(m).on("scrollbar",f.proxy(this._onScrollbar,this)),this.$container.on("fullscreenchange mozfullscreenchange webkitfullscreenchange msfullscreenchange",f.proxy(this._onFullScreenChange,this)),this.$container.on("mouseup touchend",f.proxy(this._onClearTimeout,this)),this.$container.on("contextmenu",f.proxy(this._onContextMenu,this)),f(b).on("mousedown",f.proxy(this._onDocumentMouseDown,this))},_unbind:function(){this.controls.$stage.off("click touchend",".ipgs-annotation",f.proxy(this._onAnnotationClick,this)),this.controls.$stage.off("touchstart",f.proxy(this._onBookTouch,this)),this.controls.$stage.off("touchmove",f.proxy(this._onBookTouch,this)),this.controls.$stage.off("touchend",f.proxy(this._onBookTouch,this)),this.controls.$stage.off("mousedown",f.proxy(this._onBookMouse,this)),this.controls.$stage.off(this.touchMouseEvent.down,f.proxy(this._onSwipeDown,this)),this.controls.$stage.off(this.touchMouseEvent.move,f.proxy(this._onSwipeMove,this)),this.controls.$stage.off(this.touchMouseEvent.up,f.proxy(this._onSwipeUp,this)),this.controls.$stage.off("click",f.proxy(this._onBookMouseClick,this)),this.controls.$stage.off("mousewheel",f.proxy(this._onMouseWheelNavigation,this)),this.controls.$stage.off("keydown",f.proxy(this._onKeyboardNavigation,this)),this.controls.$stage.off("dblclick",f.proxy(this._onDblClickZoomDefault,this)),this.controls.$stage.off("mousewheel",f.proxy(this._onMouseWheelZoom,this)),this.controls.$stage.off("keydown",f.proxy(this._onKeyboardZoom,this)),this.controls.$stage.off("touchstart",f.proxy(this._onPinchZoomTouchStart,this)),this.controls.$stage.off("touchend",f.proxy(this._onPinchZoomTouchEnd,this)),this.controls.$prevBtn.off("click",f.proxy(this._onPrevBtnClick,this)),this.controls.$nextBtn.off("click",f.proxy(this._onNextBtnClick,this)),f(m).off("orientationchange",f.proxy(this._onOrientationChange,this)),f(m).off("resize",f.proxy(this._onResize,this)),f(m).off("scrollbar",f.proxy(this._onScrollbar,this)),this.$container.off("fullscreenchange mozfullscreenchange webkitfullscreenchange msfullscreenchange",f.proxy(this._onFullScreenChange,this)),this.$container.off("mouseup touchend",f.proxy(this._onClearTimeout,this)),this.$container.off("contextmenu",f.proxy(this._onContextMenu,this)),f(b).off("mousedown",f.proxy(this._onDocumentMouseDown,this))},_replaceNumberTemplate:function(t,i){return t&&(i=""+i,t.replace(/\{\{(x+)\}\}/g,function(t,e){if(e.length>i.length){for(var o="",s=0;s<e.length;s++)o+="0";return(o+i).slice(-o.length)}return i}))},_createBlob:function(t,e){return new Blob([t],{type:e})},_createObjectURL:function(t,e){t=this._createBlob(t,e);return URL.createObjectURL(t)},_initThumbnails:function(){if(this.controls.$thumbnails)for(var t=this.pageHeight/this.pageWidth,e=.8*this.controls.$thumbnails.outerWidth(),o=t*e,s=0;s<this.pages.length;s++){var i=this.pages[s],a=f("<div>").addClass("ipgs-preloader"),n=f("<div>").addClass("ipgs-number").text(s+1),a=f("<div>").css({width:e+"px",height:o+"px"}).addClass("ipgs-thumb").addClass("ipgs-loading").attr("data-page-index",s).appendTo(this.controls.$thumbsWrap).append(a,n);a.$number=n,a.thumbLoading=!1,a.thumbLoaded=!1,a.image=i.image,a.pdfPage=i.pdfPage,i.$thumb=a}},_addBookmarks:function(t,e){if(e&&0<e.length){var o=f("<div>").addClass("ipgs-bookmarks").appendTo(t);t.hasClass("ipgs-bookmarks-wrap")||t.addClass("ipgs-has-childs");for(var s=0;s<e.length;s++){var i=e[s],a=this.bookmarksMap.size,n=f("<div>").addClass("ipgs-state"),h=f("<div>").addClass("ipgs-link").html(i.text),r=f("<div>").addClass("ipgs-bookmark"),g=(i.target,0!=i.folded);this.bookmarksMap.set(a,i),r.attr("data-id",a).toggleClass("ipgs-folded",g),r.append(n,h).appendTo(o),this._addBookmarks(r,i.bookmarks)}}},_initBookmarks:function(){var o,s;this.controls.$outline&&(o=f("<div>").addClass("ipgs-bookmarks-wrap"),this.controls.$outline.append(o),this.pdf?(s=this).pdf.getOutline().then(function(t){var e=[];!function t(e,o){if(e)for(var s=0;s<e.length;s++){var i,a=e[s];a.dest instanceof Array&&((i={}).text=a.title.replace(/\x00/g,""),i.dest=a.dest,a.items.length&&(i.bookmarks=[],t(a.items,i.bookmarks)),o.push(i))}}(t,e),s.config.bookmarks=e.concat(s.config.bookmarks),s._addBookmarks(o,s.config.bookmarks)}):this._addBookmarks(o,this.config.bookmarks))},_initPages:function(){for(var t=this.$container.find(".ipgs-pages"),e=t.children(),o=0,s=e.length;o<s;o++)f(e[o]).hasClass("ipgs-stage")||f(e[o]).hasClass("ipgs-toolbar")||this._addPage(e[o]);if(t.remove(),this.config.pdfAutoCreatePages&&this.pdf)for(o=0;o<this.pdfPageCount;o++){var i=f("<div>").attr({"data-type":"dynamic","data-pdf-page":o+1});this._addPage(i)}if(this.config.pageImagesUrl)for(o=0;o<this.config.pageImagesCount;o++){var a=this._replaceNumberTemplate(this.config.pageImagesUrl,this.config.pageImagesFirst+o),i=f("<div>").attr({"data-type":"dynamic","data-image":a});this._addPage(i)}function n(t,e){if(e.layers&&0<e.layers.length){var o=f("<div>").addClass("ipgs-layers");t.$layers=o,t.$front.append(o);for(var s=0;s<e.layers.length;s++){var i=e.layers[s],a=f("<div>").addClass("ipgs-layer").attr("data-layer-id",i.id).addClass(i.class);"text"==i.type&&a.text(i.text),i.htmlData&&a.append(i.htmlData),i.link&&(i=f("<a>").addClass("ipgs-layer-link").attr({href:i.link,title:"",target:i.linkNewWindow?"_blank":"_self"}),a.append(i),i.on("touchend",function(t){f(this).get(0).click()})),o.append(a)}}}for(o=0;o<this.config.pages.length;o++){var h=this.config.pages[o];"pdf"==h.type?(i=f("<div>").attr({"data-type":"dynamic","data-pdf-page":h.page}),h.showCSSClass&&i.attr("data-showcssclass",h.showCSSClass),h.hideCSSClass&&i.attr("data-hidecssclass",h.hideCSSClass),n(i=this._addPage(i),h)):"image"==h.type&&(i=f("<div>").attr({"data-type":"dynamic","data-image":h.image}),h.showCSSClass&&i.attr("data-showcssclass",h.showCSSClass),h.hideCSSClass&&i.attr("data-hidecssclass",h.hideCSSClass),n(i=this._addPage(i),h))}0<this.pages.length&&(this.pages[0].addClass("ipgs-first"),this.pages[this.pages.length-1].addClass("ipgs-last"));for(o=0;o<this.pages.length;o++)this.pages[o].attr("data-page-number",o+1);this._updateBook(!1)},_addPage:function(t){var t=f(t),e=f("<div>").addClass("ipgs-image"),o=f("<div>").addClass("ipgs-preloader"),s=f("<div>").addClass("ipgs-number"),i=f("<div>").addClass("ipgs-front"),a=f("<div>").addClass("ipgs-extra"),n=f("<div>").addClass("ipgs-shadow"),h=f("<div>").css({display:"none",width:this.pageWidth+"px",height:this.pageHeight+"px"}).addClass("ipgs-page").addClass("ipgs-loading").appendTo(this.controls.$book).append(e,i,a.append(s,o),n);return h.$image=e,h.$front=i,h.$extra=a,h.$number=s,h.$preloader=o,h.$shadow=n,h.$thumb=null,h.pageLoading=!1,h.pageLoaded=!1,h.zoom=this._getZoom(),h.image=t.data("image"),h.pdfPage=t.data("pdf-page"),h.showCSSClass=t.data("showcssclass"),h.hideCSSClass=t.data("hidecssclass"),h.isAnnotations=!1,i.append(t),this.pages.push(h),h},_updateLoadingInfo:function(t){this.controls.$bookLoadingInfo.text(t).addClass("ipgs-active")},_updateBook:function(t){for(var e=0,o=this.pages.length;e<o;e++){var s,i=this.pages[e];i.pageIndex=e,i.pageNumber=this.config.pageNumbersFirst+e,this.config.pageNumbers&&(s=e-this.pages.length,-1==f.inArray(e+1,this.config.pageNumbersHidden)&&-1==f.inArray(s,this.config.pageNumbersHidden)?i.$number.addClass("ipgs-show").text(i.pageNumber):i.$number.removeClass("ipgs-show").text(""))}this.engine.updateBook(t)},_updateSize:function(){var t,e,l=this._getZoom(),o=this.bookWidth,s=this.bookHeight,i=this.stagePadding.top,a=this.stagePadding.bottom,n=this.stagePadding.left,h=this.stagePadding.right,h=this.controls.$stage.outerWidth()-n-h,r=(this.config.autoHeight&&(r=!this.config.autoFit&&o<h?o:h,this.$container.css({height:(g=s/o)*r+i+a})),this.controls.$stage.outerHeight()-i-a),g=1,r=r<=0?s:r;this.config.responsive&&!this.config.autoFit&&(h<o||r<s)&&(g=(e=r/s)<(t=h/o)?e:t),this.config.autoFit&&(g=(e=r/s)<(t=h/o)?e:t),this.controls.$bookTransform.css({top:(r-s*g)/2+i+"px",left:(h-o*g)/2+n+"px"}),this.controls.$bookWrap.css({width:o*g+"px",height:s*g+"px"}),this.controls.$bookWrap.get(0).offsetHeight,this.controls.$bookSize.css({transform:"scale("+1/l*g+")"}),this._updateThumbnails(),this.engine.updateBookLayout()},_updateBookEngine:function(){var t,e,o,s,i,a;this.config.bookEngineLandscape&&this.config.bookEnginePortrait&&(t=this.config.bookEngineLandscape,e=this.config.bookEnginePortrait,o=this.stagePadding.top,s=this.stagePadding.bottom,i=this.stagePadding.left,a=this.stagePadding.right,(this.controls.$stage.outerWidth()-i-a)/(this.controls.$stage.outerHeight()-o-s)>=this.config.ratioPortraitToLandscape?(this.$container.addClass("ipgs-landscape").removeClass("ipgs-portrait"),this.setBookEngine(t)):(this.$container.addClass("ipgs-portrait").removeClass("ipgs-landscape"),this.setBookEngine(e)))},_updateThumbnails:function(){this.controls.$thumbnails&&this._onThumbnailsRefresh()},_updateZoomPosition:function(){var t=this._getZoom(),e=(1==t&&this._setPosition({x:0,y:0},!1),this._getPosition());this.controls.$bookTransform.css({transform:"translate3d("+e.x+"px,"+e.y+"px, 0) scale("+t+")"}),this.controls.$book.addClass("ipgs-no-transition"),this.controls.$book.css({width:this.bookWidth*t+"px",height:this.bookHeight*t+"px"});for(var o=0;o<this.pages.length;o++){var s=this.pages[o];s.css({width:this.pageWidth*t+"px",height:this.pageHeight*t+"px"}),s.$front.css({width:this.pageWidth+"px",height:this.pageHeight+"px",transform:"scale("+t+")"}),s.$extra.css({width:this.pageWidth+"px",height:this.pageHeight+"px",transform:"scale("+t+")"}),s.hasClass("ipgs-show")&&this._loadPageData(s.pageIndex)}this._updateSize();var i=this;clearTimeout(i.bookTransitionTimerId),i.bookTransitionTimerId=setTimeout(function(){i.controls.$book.removeClass("ipgs-no-transition")},300)},_getPosition:function(){return{x:this.matrix.m[4],y:this.matrix.m[5]}},_setPosition:function(t,e){var o=t.x||0,t=t.y||0;this.matrix.m[4]=o,this.matrix.m[5]=t,e&&this._updateZoomPosition()},_setDeltaPosition:function(t){var e=t.dx||0,t=t.dy||0,e=this.matrix.inverse().transformPoint(e,t),t=this.matrix.inverse().transformPoint(0,0),o=e[0]-t[0],e=e[1]-t[1];this.matrix.translate(o,e),this._updateZoomPosition()},_getZoom:function(){return this.matrix.m[0]},_setZoom:function(t,e,o){var s,t=t.zoom||1e-6;null!=this.config.zoomMin&&(t=Math.max(this.config.zoomMin,t)),null!=this.config.zoomMax&&(t=Math.min(this.config.zoomMax,t)),!o&&t==this._getZoom()||(o=this.matrix.m[4],s=this.matrix.m[5],this.matrix.reset().translate(o,s).scale(t,t),e&&this._updateZoomPosition())},_setDeltaZoom:function(t){var e=t.zoom||1,t=t.focalPoint||{x:this.matrix.m[4],y:this.matrix.m[5]},o=(this.config.zoomFocal||(t={x:this.matrix.m[4],y:this.matrix.m[5]}),this.matrix.m[0]*e),o=(null!=this.config.zoomMin&&o<this.config.zoomMin?e=this.config.zoomMin/this.matrix.m[0]:null!=this.config.zoomMax&&o>this.config.zoomMax&&(e=this.config.zoomMax/this.matrix.m[0]),this.matrix.inverse().transformPoint(t.x,t.y)),t=o[0],o=o[1];this.matrix.translate(t,o).scale(e,e).translate(-t,-o),this._updateZoomPosition()},_zoomIn:function(){var t=this._getZoom()+this.config.zoomStep;this._setZoom({zoom:t},!0,!1)},_zoomOut:function(){var t=this._getZoom()-this.config.zoomStep;this._setZoom({zoom:t},!0,!1)},_setBackgroundImage:function(t,e){var o;t.$image?e?(t.get(0).style.backgroundImage="url("+e+")",(o=new Image).onload=function(){clearTimeout(t.updateTimerId),t.updateTimerId=setTimeout(function(){t.$image.get(0).style.backgroundImage="url("+e+")"},500)},o.src=e):(t.get(0).style.backgroundImage="none",t.$image.get(0).style.backgroundImage="none"):t.css({"background-image":e?"url("+e+")":"none"}),t.pageLoading=!1,t.pageLoaded=!0,t.toggleClass("ipgs-loading",!t.pageLoaded)},_loadPageData:function(t){var g,l;null!=t&&((g=this.pages[t]).pdfPage&&g.zoom!=this._getZoom()&&(g.zoom=this._getZoom(),g.pageLoaded=!1,g.pageLoading=!1),g.pageLoaded||g.pageLoading||(g.pageLoading=!0,l=this,g.image?((t=new Image).onload=function(){l._setBackgroundImage(g,this.src),!g.$thumb||g.$thumb.pageLoaded||g.$thumb.pageLoading||l._setBackgroundImage(g.$thumb,this.src)},t.src=g.image):g.pdfPage?l.pdf&&(clearTimeout(g.updateTimerId),g.updateTimerId=setTimeout(function(){var t=g.pdfPage;l.pdfPageSize==p&&2<t&&(t=Math.ceil((t-1)/2)+1),l.pdf.getPage(t).then(function(h){var t=m.devicePixelRatio||1,e=l.controls.$book.get(0).getBoundingClientRect(),o="twopageflip"==l.engine.name.toLowerCase()?e.width/2:e.width,e=e.height,s=l.pdfPageSize==p&&1<g.pdfPage&&g.pdfPage<l.pdfPageCount,i=h.getViewport(1),a=o/(l.pdfPageSize==p?l.pdfFirstPageViewport:i).width,i=e/(l.pdfPageSize==p?l.pdfFirstPageViewport:i).height,r=h.getViewport(e<o?i:a),n=b.createElement("canvas"),i=n.getContext("2d"),a=(n.width=o,n.height=e,s&&g.pdfPage%2==1&&(r.transform[4]=-n.width),n.width*=t,n.height*=t,{canvasContext:i,viewport:r,transform:[t,0,0,t,0,0]});g.renderTask=h.render(a),g.renderTask.then(function(){n.toBlob(function(t){t=l._createObjectURL(t,"image/jpeg");l._setBackgroundImage(g,t),g.$thumb&&l._loadThumbData(g.$thumb),n=null},"image/jpeg",.9),0}),g.isAnnotations||(g.isAnnotations=!0,h.getAnnotations().then(function(t){var e=f("<div>").addClass("ipgs-annotations");l.pdfPageSize==p&&1<g.pdfPage&&g.pdfPage%2==1&&e.css({left:"-100%"}),r=r.clone({dontFlip:!0});for(var o=2,s=0;s<t.length;s++){var i,a,n=t[s];n.annotationType==o&&"Link"==n.subtype&&(a=n.rect,i=h.view,r.transform.join(","),a[0],a[1],a=PDFJS.Util.normalizeRect([a[0],i[3]-a[1]+i[1],a[2],i[3]-a[3]+i[1]]),i=f("<div>").addClass("ipgs-annotation").attr({"data-annotation-id":n.id}).css({left:a[0]+"px",top:a[1]+"px",width:a[2]-a[0]+"px",height:a[3]-a[1]+"px"}),a=f("<a>").attr({href:n.url,title:""}),e.append(i.append(a)),i=n.id,a={dest:n.dest,url:n.url,unsafeUrl:n.unsafeUrl},l.pdfAnnotationsRefCache[i]=a)}e.children().length&&(g.$layers?g.$layers.before(e):g.$front.append(e))}))})},g.updateTimerId?300:1)):(l._setBackgroundImage(g,""),!g.$thumb||g.$thumb.pageLoaded||g.$thumb.pageLoading||l._setBackgroundImage(g.$thumb,""))))},_loadThumbData:function(a){var n,t;a.pageLoaded||a.pageLoading||(a.pageLoading=!0,n=this,a.image?((t=new Image).onload=function(){n._setBackgroundImage(a,this.src)},t.src=a.image):a.pdfPage?n.pdf&&(2<(t=a.pdfPage)&&n.pdfPageSize==p&&(t=Math.ceil((t-1)/2)+1),n.pdf.getPage(t).then(function(t){var e=n.pdfPageSize==p&&1<a.pdfPage&&a.pdfPage<n.pdfPageCount,o=t.getViewport(a.width()/(t.getViewport(1).width/(e?2:1))),s=b.createElement("canvas"),i=s.getContext("2d"),e=(s.width=Math.round(a.width()),s.height=Math.round(a.height()),e&&a.pdfPage%2==1&&(o.transform[4]=-s.width),{canvasContext:i,viewport:o});t.render(e).then(function(){s.toBlob(function(t){t=n._createObjectURL(t,"image/jpeg");n._setBackgroundImage(a,t),s=null},"image/jpeg",.9),0})})):n._setBackgroundImage(a,""))},_showPage:function(t){0!=this.pages.length&&this.engine.showPage(t)},_gotoPage:function(t){0!=this.pages.length&&this.engine.gotoPage(t)},_gotoPrev:function(){this.engine.gotoPrev()},_gotoNext:function(){this.engine.gotoNext()},_setShowHidePageState:function(t,e){var o=this.pages[t];e?o.hasClass("ipgs-hide")&&(o.removeClass("ipgs-hide"),o.get(0).offsetHeight,o.addClass("ipgs-show"),o.removeClass(o.hideCSSClass||"").addClass(o.showCSSClass),this._loadPageData(t),this.$container.trigger("ipages:showpage",[this,t])):o.hasClass("ipgs-show")&&(o.removeClass("ipgs-show"),o.get(0).offsetHeight,o.addClass("ipgs-hide"),o.removeClass(o.showCSSClass||"").addClass(o.hideCSSClass),this.$container.trigger("ipages:hidepage",[this,t])),this.config.prevnextButtons&&0<this.pages.length&&(this.controls.$prevBtn.toggleClass("ipgs-active",!this.pages[0].hasClass("ipgs-show")),this.controls.$nextBtn.toggleClass("ipgs-active",!this.pages[this.pages.length-1].hasClass("ipgs-show")))},_normalizeEvent:function(t,e,o,s){return f.Event(t,{pageX:o,pageY:s,originalEvent:e})},_onShowPage:function(t){if(clearTimeout(this.pageStartTimerId),this.pageStartTimerId=null,this.config.flipSound&&this.config.flipSoundUrl&&this.pageIndexPrev!=t){var e=this.controls.$audio.get(0);try{//!!!
e.pause(),e.currentTime=0,e.play()}catch(t){}}var o;this.config.toolbar&&("ipgs-twopageflip"==this.engineClass?(o=1<(e=(t+1)%2==(o=e=0)||t+1==1||t+1==this.pages.length?t+1:t)&&e<this.pages.length?"-"+(e+1):"",this.controls.toolbar.$pagenumberLabel.text(e+o+"/"+this.pages.length)):this.controls.toolbar.$pagenumberLabel.text(t+1+"/"+this.pages.length)),this.pageIndexPrev=t},_onResize:function(){if(this.ready){for(var t=0;t<this.pages.length;t++){var e=this.pages[t];e.pageLoaded=!1,e.pageLoading=!1}this._updateZoomPosition(),this._updateBookEngine()}},_onScrollbar:function(t,e){e&&this.ready&&(this._updateSize(),this._updateBookEngine())},_onOrientationChange:function(){this._updateBookEngine()},_onBookTouch:function(t){if(!f(t.target).is("a")){var e;switch(t.type){case"touchstart":e=this.touchMouseEvent.down;break;case"touchend":e=this.touchMouseEvent.up;break;case"touchmove":t.preventDefault(),t.stopPropagation(),e=this.touchMouseEvent.move;break;default:return}var o=t.originalEvent.touches[0],o=e==this.touchMouseEvent.up?this._normalizeEvent(e,t,null,null):this._normalizeEvent(e,t,o.pageX,o.pageY);f(t.target).trigger(o)}},_onBookMouse:function(t){if(this.controls.$contextmenu.removeClass("ipgs-show").addClass("ipgs-hide"),!f(t.target).is("a")){t.preventDefault(),t.stopPropagation();var e,o=!1;switch(t.type){case"mousedown":e=this.touchMouseEvent.down,this.dragNavigation.target=t.target,this.dragNavigation.startX=this.dragNavigation.x=t.pageX,this.dragNavigation.startY=this.dragNavigation.y=t.pageY,this.controls.$stageMove.addClass("ipgs-active"),this.controls.$stageMove.on("mouseup",f.proxy(this._onBookMouse,this)),this.controls.$stageMove.on("mouseout",f.proxy(this._onBookMouse,this)),this.controls.$stageMove.on("mousemove",f.proxy(this._onBookMouse,this)),this.controls.$stage.focus();break;case"mouseup":this.dragNavigation.startX==this.dragNavigation.x&&this.dragNavigation.startY==this.dragNavigation.y&&(o=!0);case"mouseout":e=this.touchMouseEvent.up,this.controls.$stageMove.removeClass("ipgs-active"),this.controls.$stageMove.off("mouseup",f.proxy(this._onBookMouse,this)),this.controls.$stageMove.off("mouseout",f.proxy(this._onBookMouse,this)),this.controls.$stageMove.off("mousemove",f.proxy(this._onBookMouse,this));break;case"mousemove":e=this.touchMouseEvent.move,this.dragNavigation.x=t.pageX,this.dragNavigation.y=t.pageY;break;default:return}var s=this._normalizeEvent(e,t,t.pageX,t.pageY);f(t.target).trigger(s),o&&this.dragNavigation.target&&this.dragNavigation.target.click()}},_onSwipeDown:function(t){this.lastDelta={x:t.pageX,y:t.pageY},this.controls.$bookTransform.addClass("ipgs-no-transition"),1==this._getZoom()&&this.engine.onSwipeDown(t)},_onSwipeMove:function(t){1==this._getZoom()?this.engine.onSwipeMove(t):(this._setDeltaPosition({dx:t.pageX-this.lastDelta.x,dy:t.pageY-this.lastDelta.y}),this.lastDelta.x=t.pageX,this.lastDelta.y=t.pageY)},_onSwipeUp:function(t){this.controls.$bookTransform.removeClass("ipgs-no-transition"),1==this._getZoom()&&this.engine.onSwipeUp(t)},_onBookMouseClick:function(t,e){e=e||t.target;var o=f(e).closest(".ipgs-page");if(o.length)switch(this.engineClass){case"ipgs-twopageflip":o.data("page-number")%2==0?this._gotoPrev():this._gotoNext();break;case"ipgs-onepageflip":case"ipgs-onepageswipe":this._gotoNext()}},_onPrevBtnClick:function(t){t.preventDefault(),t.stopPropagation(),this.controls.$stage.focus(),this._gotoPrev()},_onNextBtnClick:function(t){t.preventDefault(),t.stopPropagation(),this.controls.$stage.focus(),this._gotoNext()},_onKeyboardNavigation:function(t){switch(t.which){case 37:this.gotoPrev();break;case 39:this.gotoNext()}},_onMouseWheelNavigation:function(t,e){this.config.mouseWheelPreventDefault&&(t.preventDefault(),t.stopPropagation()),e<0?this.gotoPrev():this.gotoNext()},_onDblClickZoomDefault:function(t){this._setZoom({zoom:1},!0,!1)},_onDblTapZoomDefault:function(t){var e;this.tapped?(clearTimeout(this.tapped),this.tapped=null,this._setZoom({zoom:1},!0,!1)):(e=this).tapped=setTimeout(function(){e.tapped=null},300)},_onMouseWheelZoom:function(t,e){this.config.mouseWheelPreventDefault&&(t.preventDefault(),t.stopPropagation());var o=this.controls.$stage.get(0).getBoundingClientRect(),s=t.clientX,t=t.clientY;s-=o.left,t-=o.top,s={x:s-(o.right-o.left)/2,y:t-(o.bottom-o.top)/2},this._setDeltaZoom({zoom:1+.1*e,focalPoint:s})},_onKeyboardZoom:function(t){switch(t.which){case 189:case 109:var e=this._getZoom()-this.config.zoomStep;this._setZoom({zoom:e},!0,!1);break;case 187:case 107:e=this._getZoom()+this.config.zoomStep;this._setZoom({zoom:e},!0,!1)}},_onPinchZoomTouchStart:function(t){this.pinchZoom.aStart=t.originalEvent.touches[0]&&1<t.originalEvent.touches.length,this.pinchZoom.bStart=t.originalEvent.touches[1],!this.pinchZoom.aIsMoving&&!this.pinchZoom.bIsMoving&&this.pinchZoom.aStart&&this.pinchZoom.bStart&&(t.preventDefault(),t.stopPropagation(),this.controls.$stage.focus(),this.controls.$bookTransform.addClass("ipgs-no-transition"),this.pinchZoom.aStartX=t.originalEvent.touches[0].pageX,this.pinchZoom.aStartY=t.originalEvent.touches[0].pageY,this.pinchZoom.bStartX=t.originalEvent.touches[1].pageX,this.pinchZoom.bStartY=t.originalEvent.touches[1].pageY,this.controls.$stage.on("touchmove",f.proxy(this._onPinchZoomTouchMove,this)),this.pinchZoom.zoom=this._getZoom(),this.pinchZoom.startDate=(new Date).getTime(),this.pinchZoom.aCurX=this.pinchZoom.aStartX,this.pinchZoom.aCurY=this.pinchZoom.aStartY,this.pinchZoom.bCurX=this.pinchZoom.bStartX,this.pinchZoom.bCurY=this.pinchZoom.bStartY,this.pinchZoom.aIsMoving=!0,this.pinchZoom.bIsMoving=!0)},_onPinchZoomTouchMove:function(t){var e,o,s,i,a,n,h;(this.pinchZoom.aIsMoving||this.pinchZoom.bIsMoving)&&(this.pinchZoom.aCurX=t.originalEvent.touches[0].pageX,this.pinchZoom.aCurY=t.originalEvent.touches[0].pageY,this.pinchZoom.bCurX=t.originalEvent.touches[1].pageX,this.pinchZoom.bCurY=t.originalEvent.touches[1].pageY,(new Date).getTime(),this.pinchZoom.startDate,t=this.pinchZoom.aCurX,e=this.pinchZoom.aCurY,o=this.pinchZoom.bCurX,s=this.pinchZoom.bCurY,n=t-this.pinchZoom.aStartX,h=e-this.pinchZoom.aStartY,i=o-this.pinchZoom.bStartX,a=s-this.pinchZoom.bStartY,Math.abs(n),Math.abs(h),Math.abs(i),Math.abs(a),n=Math.sqrt((this.pinchZoom.aStartX-this.pinchZoom.bStartX)*(this.pinchZoom.aStartX-this.pinchZoom.bStartX)+(this.pinchZoom.aStartY-this.pinchZoom.bStartY)*(this.pinchZoom.aStartY-this.pinchZoom.bStartY))-Math.sqrt((t-o)*(t-o)+(e-s)*(e-s)),h=this.pinchZoom.zoom-n*this.config.pinchZoomCoef,this._setZoom({zoom:h},!0,!1))},_onPinchZoomTouchEnd:function(t){t.preventDefault(),t.stopPropagation(),this.controls.$stage.off("touchmove",f.proxy(this._onPinchZoomTouchMove,this)),this.controls.$bookTransform.addClass("ipgs-no-transition"),this._pinchZoomReset()},_pinchZoomReset:function(){this.pinchZoom.aStartX=!1,this.pinchZoom.aStartY=!1,this.pinchZoom.bStartX=!1,this.pinchZoom.bStartY=!1,this.pinchZoom.startDate=!1,this.pinchZoom.aIsMoving=!1,this.pinchZoom.bIsMoving=!1},_onToolbarControlClick:function(t){this.controls.$stage.focus()},_onPageFirst:function(t){this.gotoPage(0)},_onPagePrev:function(t){this.gotoPrev()},_pageNumberInputShow:function(){this.controls.toolbar.$pagenumber.addClass("ipgs-pagenumber-input"),this.controls.toolbar.$pagenumberInput.focus().val(this.currPage+1)},_pageNumberInputHide:function(){this.controls.toolbar.$pagenumber.removeClass("ipgs-pagenumber-input")},_pageNumberInputUpdate:function(){var t=parseInt(this.controls.toolbar.$pagenumberInput.val(),10);t<=0?t=1:t>this.pages.length?t=this.pages.length:isNaN(t)&&(t=this.currPage+1),this.controls.toolbar.$pagenumberInput.val(t),this.gotoPage(t)},_onPageNumberLabelClick:function(t){t.preventDefault(),t.stopPropagation(),this.$body.one("click",f.proxy(this._onPageNumberInputHide,this)),this._pageNumberInputShow()},_onPageNumberInputClick:function(t){t.preventDefault(),t.stopPropagation()},_onPageNumberInputHide:function(t){this._pageNumberInputUpdate(),this._pageNumberInputHide()},_onPageNumberInputKeyup:function(t){13==t.which&&this._pageNumberInputUpdate(),27==t.which&&(this.$body.off("click",f.proxy(this._onPageNumberInputHide,this)),this._pageNumberInputHide())},_onPageNext:function(t){this.gotoNext()},_onPageLast:function(t){this.gotoPage(this.pages.length)},_onToggleThumbnails:function(t){this.controls.$thumbnails.toggleClass("ipgs-active"),this.controls.toolbar.$thumbnails.toggleClass("ipgs-active"),this.controls.$thumbnails.hasClass("ipgs-active")&&this._onThumbnailsScroll(),this.controls.$outline.hasClass("ipgs-active")&&(this.controls.$outline.toggleClass("ipgs-active"),this.controls.toolbar.$outline.toggleClass("ipgs-active"))},_onThumbnailsScroll:function(t){clearTimeout(this.thumbnailsScrollTimerId),this.thumbnailsScrollTimerId=setTimeout(f.proxy(this._onThumbnailsRefresh,this),this.thumbnailsScrollTimeout)},_onThumbnailsRefresh:function(){if(this.controls.$thumbnails.hasClass("ipgs-active")&&0!=this.pages.length)for(var t=this.controls.$thumbsWrap.find(".ipgs-thumb:first-child").outerHeight(!0),e=this.controls.$thumbsWrap.outerHeight(),o=this.controls.$thumbsWrap.scrollTop(),e=o+e,o=Math.floor(o/t),s=Math.floor(e/t),i=o;i<=s&&i<this.pages.length;i++)this._loadThumbData(this.pages[i].$thumb)},_onThumbClick:function(t){t.preventDefault,t.stopPropagation();t=f(t.target).data("page-index");this._gotoPage(t)},_onToggleOutline:function(t){this.controls.$outline.toggleClass("ipgs-active"),this.controls.toolbar.$outline.toggleClass("ipgs-active"),this.controls.$thumbnails.hasClass("ipgs-active")&&(this.controls.$thumbnails.toggleClass("ipgs-active"),this.controls.toolbar.$thumbnails.toggleClass("ipgs-active"))},_onBookmarkClick:function(t){t.preventDefault,t.stopPropagation();var e,o=f(t.currentTarget);f(t.target).is(".ipgs-state")?o.toggleClass("ipgs-folded"):(t=this.bookmarksMap.get(o.data("id")))&&(t.link?(o=parseInt(t.link,10),isNaN(o)?(e=t.target?"_"+t.target:"_self",e=f("<a>").attr("href",t.link).attr("target",e),this.$body.append(e),e.get(0).click(),e.remove()):(o<0?o+=this.pages.length:o-=1,this._gotoPage(o))):t.dest&&this._onPDFPageNavigation(t.dest))},_onAnnotationClick:function(t){t.preventDefault,t.stopPropagation();var t=f(t.currentTarget),e=t.data("annotation-id"),e=this.pdfAnnotationsRefCache[e];return e&&(e.dest?this._onPDFPageNavigation(e.dest):e.url&&(t=f("<a>").attr("href",e.url).attr("target","_blank"),this.$body.append(t),t.get(0).click(),t.remove())),!1},_onPDFPageNavigation:function(t){var s=this;function i(o){var t=o instanceof Object?s.pdfPagesRefCache[o.num+" "+o.gen+" R"]:o+1;if(t){t>s.pdf.numPages&&(t=s.pdf.numPages);for(var e=0;e<s.pages.length;e++)if(s.pages[e].pdfPage==t){s._gotoPage(e);break}}else s.pdf.getPageIndex(o).then(function(t){var e=o.num+" "+o.gen+" R";s.pdfPagesRefCache[e]=t+1,i(o)})}t instanceof Array?i(t[0]):"string"==typeof t&&this.pdf.getDestination(t).then(function(t){t instanceof Array&&i(t[0])})},_onClearTimeout:function(t){clearTimeout(this.zoomTimerId)},_onContextMenu:function(t){this.config.contextmenu&&(t.preventDefault(),this.controls.$contextmenu.removeClass("ipgs-hide").addClass("ipgs-show").css({top:t.pageY+"px",left:t.pageX+"px"}))},_onDocumentMouseDown:function(t){this.config.contextmenu&&0<!f(t.target).parents(".ipgs-contextmenu").length&&this.controls.$contextmenu.removeClass("ipgs-show").addClass("ipgs-hide")},__zoomIn:function(){var t=this;this.zoomTimerId=setTimeout(function(){t._zoomIn(),t.__zoomIn()},10)},__zoomOut:function(){var t=this;this.zoomTimerId=setTimeout(function(){t._zoomOut(),t.__zoomOut()},10)},_onZoomIn:function(t){clearTimeout(this.zoomTimerId),this.__zoomIn()},_onZoomOut:function(t){clearTimeout(this.zoomTimerId),this.__zoomOut()},_onZoomDefault:function(t){this._setZoom({zoom:1},!0,!1)},_onToggleSound:function(t){this.config.flipSound=!this.config.flipSound,this.controls.toolbar.$sound.toggleClass("ipgs-disable",!this.config.flipSound)},_onFullScreenChange:function(t){b.fullscreen||b.mozFullScreen||b.webkitIsFullScreen||b.msFullscreenElement?(this.$container.addClass("ipgs-fullscreen"),this.$container.get(0).offsetHeight,this.controls.toolbar.$fullscreen&&this.controls.toolbar.$fullscreen.addClass("ipgs-active")):(this.$container.removeClass("ipgs-fullscreen"),this.$container.get(0).offsetHeight,this.controls.toolbar.$fullscreen&&this.controls.toolbar.$fullscreen.removeClass("ipgs-active"));var e=this;setTimeout(function(){e._onResize()},100)},_onToggleFullscreen:function(t){if(b.fullscreenEnabled||b.webkitFullscreenEnabled)if(this.$container.hasClass("ipgs-fullscreen"))try{b.exitFullscreen?b.exitFullscreen():b.mozCancelFullScreen?b.mozCancelFullScreen():b.webkitCancelFullScreen?b.webkitCancelFullScreen():b.msExitFullscreen&&b.msExitFullscreen()}catch(t){console.error("The browser does not support the fullscreen API")}else try{var e=this.$container.get(0);e.requestFullscreen?e.requestFullscreen():e.mozRequestFullScreen?e.mozRequestFullScreen():e.webkitRequestFullscreen?e.webkitRequestFullscreen():e.msRequestFullscreen&&e.msRequestFullscreen()}catch(t){console.error("The browser does not support the fullscreen API")}else this.$container.toggleClass("ipgs-fullscreen"),this.$container.hasClass("ipgs-fullscreen")?(this.controls.toolbar.$fullscreen&&this.controls.toolbar.$fullscreen.addClass("ipgs-active"),this.controls.$placeholder.insertBefore(this.$container),this.$container.detach(),f("body").append(this.$container)):(this.controls.toolbar.$fullscreen&&this.controls.toolbar.$fullscreen.removeClass("ipgs-active"),this.$container.detach(),this.$container.insertAfter(this.controls.$placeholder),this.controls.$placeholder.remove()),this._onResize()},_onDownload:function(t){var e;this.config.pdfUrl&&(e=this.config.pdfUrl.substring(this.config.pdfUrl.lastIndexOf("/")+1,this.config.pdfUrl.length),e=f("<a>").attr("href",this.config.pdfUrl).attr("download",e),this.$body.append(e),e.get(0).click(),e.remove())},_getShareUrl:function(){return m.location.href},_buildUrl:function(t,e){var o,s=0;for(o in e)t+=(s?"&":"")+o+"="+encodeURIComponent(e[o]),s++;return t},_onToggleShare:function(t){t?(t.preventDefault(),t.stopPropagation(),t=t.toElement||t.relatedTarget,0!==this.controls.$shareDialog.has(t).length||this.controls.$shareDialog.is(t)||(this.controls.$share.toggleClass("ipgs-active"),this.controls.toolbar.$share.toggleClass("ipgs-active"))):(this.controls.$share.toggleClass("ipgs-active"),this.controls.toolbar.$share.toggleClass("ipgs-active"))},_executeShareUrl:function(t){t=f("<a>").attr("href",t).attr("target","_blank");this.$body.append(t),t.get(0).click(),t.remove()},_onShareClick:function(t,e){var o="",s={};switch(t){case"facebook":o="http://www.facebook.com/sharer.php?",s={u:this._getShareUrl()};break;case"twitter":o="http://twitter.com/share?",s={url:this._getShareUrl()};break;case"google":o="https://plus.google.com/share?",s={url:this._getShareUrl()};break;case"linkedin":o="http://www.linkedin.com/shareArticle?",s={mini:"true",url:this._getShareUrl()};break;case"email":o="mailto:?",s={subject:"",body:this._getShareUrl()};break;default:return}this._executeShareUrl(this._buildUrl(o,s))},_destroy:function(){var t=this.$container,e=this.$container.find(".ipgs-come-back");//!!!
this._unbind(),this.pdf&&this.pdf.destroy&&this.pdf.destroy(),this.pdf=null,t.removeClass("ipgs ipgs-ready").removeClass(this.engineClass).removeClass(this.themeClass).empty(),f(e).each(function(){t.append(f(this).removeClass("ipgs-come-back"))})},getQueryParameters:function(){var t=location.search.slice(1),s={};return t.replace(/([^=]*)=([^&]*)&*/g,function(t,e,o){s[e]=o}),s},gotoPage:function(t){this._gotoPage(t-1)},gotoNext:function(){this._gotoNext()},gotoPrev:function(){this._gotoPrev()},zoomIn:function(){this._zoomIn()},zoomOut:function(){this._zoomOut()},zoomDefault:function(){this._setZoom({zoom:1},!0,!1)},setBookEngine:function(t){var e=t?"ipgs-"+t.toLowerCase():null;if(this.engineClass==e)return!1;switch(e){case"ipgs-twopageflip":case"ipgs-onepageflip":case"ipgs-onepageswipe":break;default:return console.error(this.config.txtFailedEngine+" ["+t+"]"),!1}this.controls.$bookTransform.addClass("ipgs-no-transition"),this.controls.$book.addClass("ipgs-no-transition"),this.$container.removeClass(this.engineClass),this.engineClass=e,this.$container.addClass(this.engineClass);for(var o=0,s=this.pages.length;o<s;o++){var i=this.pages[o];i.removeClass("ipgs-left").removeClass("ipgs-right"),i.css({left:""})}switch(this.controls.$book.css({transform:""}),this.engineClass){case"ipgs-twopageflip":this.bookWidth=2*this.config.pageWidth,this.engine=new $(this,f.extend(!0,{},this.config.twoPageFlip));break;case"ipgs-onepageflip":this.bookWidth=this.config.pageWidth,this.engine=new C(this,f.extend(!0,{},this.config.onePageFlip));break;case"ipgs-onepageswipe":this.bookWidth=this.config.pageWidth,this.engine=new y(this,f.extend(!0,{},this.config.onePageSwipe))}this.controls.$book.css({width:this.bookWidth}),0<this.pages.length&&this._updateBook(1),this._updateSize(),this.controls.$bookTransform.removeClass("ipgs-no-transition"),this.controls.$book.removeClass("ipgs-no-transition")}},f.fn.ipages=function(t,e){return"instance"==t?f(this).data(_)||void console.error('Calling "instance" method on not initialized instance is forbidden'):this.each(function(){var h=f(this),r=h.data(_),s=h.data("json-src"),g=h.data("pdf-src"),l=h.data("pdf-disable-range-requests"),u=h.data("book-engine"),p=parseInt(h.data("page-width"),10),c=parseInt(h.data("page-height"),10),d=f.isPlainObject(t)?t:s?null:{};if("destroy"==t)return r?(h.removeData(_),void r._destroy()):void console.error('Calling "destroy" method on not initialized instance is forbidden');function e(){for(var t=f.extend(!0,{},P.prototype.defaultConfig,d),e=0;e<t.pages.length;e++){var o=f.extend(!0,{},P.prototype.defaultPage,t.pages[e]);(t.pages[e]=o).pdfpage&&(o.page=o.pdfpage,delete o.pdfpage)}function s(t,e){for(var o=[],s=0;s<e.length;s++)for(var i=e[s],a=0;a<t.length;a++)(h=t[a]).type==i.type&&(n=f.extend(!0,{},h,i),o.push(n));for(s=0;s<t.length;s++){for(var n,h=t[s],r=!0,a=0;a<e.length;a++){i=e[a];if(h.type==i.type){r=!1;break}}r&&(n=f.extend(!0,{},h),o.push(n))}return o}if(t.bookEngine=u||t.bookEngine,t.pageWidth=isNaN(p)?t.pageWidth:p,t.pageHeight=isNaN(c)?t.pageHeight:c,"boolean"==typeof l&&(t.pdfDisableRangeRequests=l),null==t.pdfUrl&&g&&(t.pdfUrl=g,t.pdfAutoCreatePages=!0,t.pageSizeAuto=!0),d.toolbarControls&&d.toolbarControls instanceof Array&&(t.toolbarControls=s(P.prototype.defaultConfig.toolbarControls,d.toolbarControls)),d.shareControls&&d.shareControls instanceof Array&&(t.shareControls=s(P.prototype.defaultConfig.shareControls,d.shareControls)),d.bookmarks&&d.bookmarks instanceof Array&&(t.bookmarks=f.extend(!0,[],d.bookmarks)),null==t.flipSoundUrl){var i=b.getElementsByTagName("script"),a="jquery.ipages.min",n=null;if(i&&0<i.length)for(var e in i)if(i[e].src&&i[e].src.match(new RegExp(a+"\\.js$"))){n=i[e].src.replace(new RegExp("(.*)"+a+"\\.js$"),"$1");break}n&&(t.flipSoundUrl=n+"page-flip.mp3")}r=new P(h,t),h.data(_,r)}if(r&&(h.removeData(_),r._destroy(),r=null),null==d){let t={url:s=w(s),type:"GET",dataType:"json",contentType:"application/json"};const o=new URLSearchParams(m.location.search);ipages_flipbook_globals&&o.has("preview")&&(t.headers={"X-WP-Nonce":ipages_flipbook_globals.api.nonce}),f.ajax(t).done(function(t){d=f.isPlainObject(t)?t:{}}).fail(function(t,e,o){console.error(o),d={toolbar:!1,jsonFail:!0,jsonUrl:s}}).always(function(){e()})}else e()})},f(".ipgs-flipbook").ipages()}(jQuery,window,document);